---
title: 'IDBTransaction: abort event'
slug: Web/API/IDBTransaction/abort_event
tags:
  - Event
  - IDBTransaction
  - Reference
  - abort
---
<p>{{APIRef("IndexedDB")}}</p>

<p>The <code>abort</code> event is fired when an <code>IndexedDB</code> transaction is aborted.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>Yes</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{DOMxRef("Event")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{DOMxRef("IDBTransaction.onabort", "onabort")}}</td>
  </tr>
 </tbody>
</table>

<p>This can happen for any of the following reasons:</p>

<ul>
 <li>bad requests, (for example, trying to add the same key twice, or put the same index key when the key has a uniqueness constraint),</li>
 <li>an explicit {{DOMxRef("IDBTransaction.abort", "abort()")}} call</li>
 <li>an uncaught exception in the request's success/error handler,</li>
 <li>an I/O error (an actual failure to write to disk, for example disk detached, or other OS/hardware failure)</li>
 <li>quota exceeded.</li>
</ul>

<h2 id="Examples">Examples</h2>

<p>This example opens a database (creating the database if it does not exist), then opens a transaction, adds a listener to the <code>abort</code> event, then aborts the transaction to trigger the event.</p>

<pre class="brush: js;">// Open the database
const DBOpenRequest = window.indexedDB.open('toDoList', 4);

DBOpenRequest.onupgradeneeded = event =&gt; {
  const db = event.target.result;

  db.onerror = () =&gt; {
    console.log('Error creating database');
  };

  // Create an objectStore for this database
  var objectStore = db.createObjectStore('toDoList', { keyPath: 'taskTitle' });

  // define what data items the objectStore will contain
  objectStore.createIndex('hours', 'hours', { unique: false });
  objectStore.createIndex('minutes', 'minutes', { unique: false });
  objectStore.createIndex('day', 'day', { unique: false });
  objectStore.createIndex('month', 'month', { unique: false });
  objectStore.createIndex('year', 'year', { unique: false });
};

DBOpenRequest.onsuccess = event =&gt; {
  const db = DBOpenRequest.result;

  // open a read/write db transaction, ready for adding the data
  const transaction = db.transaction(['toDoList'], 'readwrite');

  // add a listener for `abort`
  transaction.addEventListener('abort', () =&gt; {
    console.log('Transaction was aborted');
  });

  // abort the transaction
  transaction.abort();
};
</pre>

<p>The same example, but assigning the event handler to the {{DOMxRef("IDBTransaction.onabort", "onabort")}} property:</p>

<pre class="brush: js;">// Open the database
const DBOpenRequest = window.indexedDB.open('toDoList', 4);

DBOpenRequest.onupgradeneeded = event =&gt; {
  const db = event.target.result;

  db.onerror = () =&gt; {
    console.log('Error creating database');
  };

  // Create an objectStore for this database
  var objectStore = db.createObjectStore('toDoList', { keyPath: 'taskTitle' });

  // define what data items the objectStore will contain
  objectStore.createIndex('hours', 'hours', { unique: false });
  objectStore.createIndex('minutes', 'minutes', { unique: false });
  objectStore.createIndex('day', 'day', { unique: false });
  objectStore.createIndex('month', 'month', { unique: false });
  objectStore.createIndex('year', 'year', { unique: false });
};

DBOpenRequest.onsuccess = event =&gt; {
  const db = DBOpenRequest.result;

  // open a read/write db transaction, ready for adding the data
  const transaction = db.transaction(['toDoList'], 'readwrite');

  // add a listener for `abort`
  transaction.onabort = (event) =&gt; {
    console.log('Transaction was aborted');
  };

  // abort the transaction
  transaction.abort();
};
</pre>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.IDBTransaction.abort_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/IndexedDB/Using_IndexedDB">Using IndexedDB</a></li>
 <li>{{DOMxRef("IDBTransaction.onabort", "onabort")}} event handler property</li>
</ul>
